/* GTKstereograph 0.17a, 19/08/2001;
 * Copyright (c) 2000-2001 by Fabian Januszewski <fabian.linux@januszewski.de>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */


#include <gtk/gtk.h>

#include "renderer.h"
#include "gfxio.h"

struct RENDERER_PARAMS Renderer_Params;
struct RENDERER_DATA Renderer_Data;
struct GFX_DATA GFX_Base, GFX_Texture, GFX_Stereo;
char *base_file_name;
char *texture_file_name;
char *stereo_file_name;
int Stereo_Triangles;
// char **T_base_file_name;
// char **T_texture_file_name;

struct GFX_DATA *gfx_tex_to_merge[3];


/* gtk stuff */

GtkWidget *resize_window1;
GtkWidget *random_window1;
GtkWidget *tex_align_window1;
GtkWidget *base_gfx_window1;
GtkWidget *texture_gfx_window1;
GtkWidget *stereo_gfx_window1;
//GtkWidget *gfx_window1;
GtkWidget *main_window1;
GtkWidget *info_dialog1;
GtkWidget *base_open_dialogue1;
GtkWidget *texture_open_dialogue1;
GtkWidget *stereogram_save_dialogue1;


/* my own defines */
gboolean
on_tex_align_drawingarea1_button_press_event (GtkWidget       *widget,
                                              GdkEventButton  *event,
                                              gpointer         user_data);


gboolean
on_darea_expose (GtkWidget *widget,
                 GdkEventExpose *event,
                 struct GFX_DATA *gfx);

GtkWidget* create_my_gfx_window1 (struct GFX_DATA *gfx, char *gtk_descr, char *window_title);
GtkWidget* create_my_tex_align_window1 (struct GFX_DATA *gfx_tex_to_merge[3], char *gtk_descr, char *window_title);
GtkWidget* create_my_resize_window1 (int width);


/* glade origs */

void
on_main_menu_file1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_main_menu_base1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_main_menu_texture1_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_main_menu_stereogram1_activate      (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_main_menu_help1_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_ok_button1_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button1_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_main_window1_destroy                (GtkObject       *object,
                                        gpointer         user_data);

gboolean
on_base_open_dialogue1_delete_event    (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

gboolean
on_texture_open_dialogue1_delete_event (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

gboolean
on_stereogram_save_dialogue1_delete_event
                                        (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_ok_button2_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button2_clicked              (GtkButton       *button,
                                        gpointer         user_data);

void
on_ok_button3_clicked                  (GtkButton       *button,
                                        gpointer         user_data);

void
on_cancel_button3_clicked              (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_info_dialog1_delete_event           (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_info_ok_button1_clicked             (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_gfx_window1_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_msg_dialog_button1_clicked          (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_msg_dialog1_delete_event            (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_main_menu_quit_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_baseloadmenu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_baseshowmenu_activate               (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_textureloadmenu_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_generaterandommenu_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_textureshowmenu_activate            (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_texturealignmentmenu_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_texturecutmenu_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_stereogramrendermenu_activate       (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_stereogramshowmenu_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_stereogramsavemenu_activate         (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_aboutmenu_activate                  (GtkMenuItem     *menuitem,
                                        gpointer         user_data);

void
on_base_load_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_base_show_button_clicked            (GtkButton       *button,
                                        gpointer         user_data);

void
on_texture_load_button_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_texture_random_button_clicked       (GtkButton       *button,
                                        gpointer         user_data);

void
on_texture_show_button_clicked         (GtkButton       *button,
                                        gpointer         user_data);

void
on_texture_alignment_button_clicked    (GtkButton       *button,
                                        gpointer         user_data);

void
on_texture_cut_button_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_render_button_clicked               (GtkButton       *button,
                                        gpointer         user_data);

void
on_stereogram_save_button_clicked      (GtkButton       *button,
                                        gpointer         user_data);

void
on_stereogram_show_button_clicked      (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_random_window1_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_random_generate_button_clicked      (GtkButton       *button,
                                        gpointer         user_data);

gboolean
on_resize_window1_delete_event         (GtkWidget       *widget,
                                        GdkEvent        *event,
                                        gpointer         user_data);

void
on_resize_cut_button_clicked           (GtkButton       *button,
                                        gpointer         user_data);

void
on_base_invert_button_clicked          (GtkButton       *button,
                                        gpointer         user_data);

void
on_baseinvertmenu_activate             (GtkMenuItem     *menuitem,
                                        gpointer         user_data);
